package utils

import (
	"crypto/rand"
	"crypto/sha256"
	"encoding/base64"
	"fmt"
	"log"
)

func CreateToken() (err error, token string) {
	b := make([]byte, 8)
	_, err = rand.Read(b)
	if err != nil {
		log.Fatal(err)
		return
	}
	token = fmt.Sprintf("%x", b)
	return
}

func CreateUUID() (err error, uuid string) {
	b := make([]byte, 16)
	_, err = rand.Read(b)
	if err != nil {
		log.Fatal(err)
		return
	}
	uuid = fmt.Sprintf("%x-%x-%x-%x-%x", b[0:4], b[4:6], b[6:8], b[8:10], b[10:])
	return
}

func Hash(s []byte) (err error, hashString string) {
	h := sha256.New()
	_, err = h.Write(s)
	if nil != err {
		return
	}
	hash := h.Sum(nil)
	hashString = base64.StdEncoding.EncodeToString(hash)
	return
}
